<template>
  <el-row v-loading="loading">
    <template v-if="carForm && carForm.id">
      <el-col :span="24">
        <el-page-header @back="$router.go(-1)" content="Car info:">
        </el-page-header>
        <span>Reg. number:</span>
        <h4>{{ carForm.registration_mark }}</h4>
        <span>Mileage:</span>
        <h4>{{ carForm.mileage }}</h4>
        <span>Purchase date:</span>
        <h4>{{ $moment(carForm.purchase_date).format('YYYY-MM-DD') }}</h4>
        <span>Car type:</span>
        <h4>{{ carForm.car_type_id == 0 ? "Passenger" : "Freight" }}</h4>

        <el-button type="danger" @click="handleDeleteCar">Delete</el-button>
      </el-col>
      <el-col :gutter="3" :span="12" v-if="car_route && car_route.id">
        <el-divider></el-divider>
        <h3>Currently reserved for route:</h3>
        <span>Way from to:</span>
        <h4>{{ car_route.cityA + ' - ' + car_route.cityB }}</h4>
        <span>Mileage:</span>
        <h4>{{ carForm.mileage }}</h4>
        <span>Purchase date:</span>
        <h4>{{ carForm.purchase_date }}</h4>
        <span>Car type:</span>
        <h4>{{ carForm.car_type_id == 0 ? "Passenger" : "Freight" }}</h4>
      </el-col>
      <el-col v-else>
        <el-divider></el-divider>
        This car is not reserved for any route.
      </el-col>
    </template>

    <el-col v-else-if="!loading">
      Not found car with id: <b>{{ id }}</b>
    </el-col>
    <el-col v-else> Loading... </el-col>
  </el-row>
</template>

<script>
  import carModelMixin from "@/mixins/carModelMixin";
  import { mapActions } from "vuex";
  import { ACTIONS_DELETE_CAR } from "@/plugins/constants";

  export default {
    mixins: [carModelMixin],
    methods: {
      ...mapActions({ ACTIONS_DELETE_CAR }),

      handleDeleteCar() {
        this.ACTIONS_DELETE_CAR(this.id)
          .then((_) => {
            this.$router.push({ name: "Cars" });
            this.$notify.success({ message: "Successfully deleted car" });
          })
          .catch(({ response }) =>
            this.$notify.error({ message: response.data })
          );
      },
    },
  };
</script>

<style scoped>
  h4 {
    margin-top: 0px !important;
  }
</style>